
(
/*MCR Installer Version 2
By Ravihara Weerathunge
4:03 PM 6/20/2014
*/

global 	usericons_array, userscripts_array, usermacros_array,end_msg
	
/*Destination Paths*/
global user_scripts_path= getdir#userScripts +"\\"
global user_icons_path=getdir#userIcons +"\\"
global user_macros_path=getdir#userMacros+"\\"
	
/*Source Paths*/
global source_icon_path = getFilenamePath(getSourceFileName())+"icons"+"\\"	
global source_scripts_path = getFilenamePath(getSourceFileName())+"scripts"+"\\"		
global source_macros_path = getFilenamePath(getSourceFileName())+"macros"+"\\"
	
/*Setup.INI path*/	
global setup_INI= getFilenamePath(getSourceFileName())+"setup.ini"
global logo_bitmap_file = getFilenamePath(getSourceFileName())+"logo.bmp"
global script_folder_name
global package_name
global group_name

script_folder_name = getINISetting setup_INI	"setup_info"	"scriptfolder"
package_name = getINISetting setup_INI	"setup_info"	"pakagename"	
end_msg = getINISetting setup_INI "setup_info" "end_msg"
group_name= "Install "+package_name
	
-- /// Interface//	
	rollout syscale_installer package_name width:208 height:104 ( --DIALOG 1 OEPN
	groupBox grp1 "" pos:[8,3] width:192 height:96
	bitmap installer_bitmap "Bitmap" pos:[16,19] width:176 height:40 fileName:logo_bitmap_file
	button install_button "Install" pos:[16,67] width:88 height:24 enabled:false
	button uninstall_button "Unistall" pos:[112,67] width:80 height:24 enabled:false
		
	rollout output_window "output window" ( --DIALOG 2 OPEN
	dotNetControl outputtext "System.Windows.Forms.RichTextBox" pos:[2,5] width:240 height:128 
	--editText outputtext " " pos:[2,5] width:240 height:128 readOnly:true
	
	--EV when text in the richtextbox is changed go to last line
	on outputtext TextChanged do (
	--output_window.outputtext.ScrollToCaret()
	)
	
	on outputtext LinkClicked do(
		ShellLaunch "http:\\www.ravihara.com" ""
	)

	
	--EV When second dialog is visible
	on output_window open do (
	--initialize the text feild
	--output_window.outputtext.AcceptsReturn = true;
	output_window.outputtext.AcceptsTab = true;
	output_window.outputtext.WordWrap = true;
	output_window.outputtext.Multiline = true;
	--output_window.outputtext.ScrollBars = (dotNetClass "System.Windows.Forms.ScrollBars").Vertical;
	
		)
		
)--DIALOG 2 END

--/////////////////////////////////////////////////////////////////////////////STARTING FUNCTIONS

-- /////////////////////////////Fucnction goto last line
	fn goto_last_line = (
		output_window.outputtext.ScrollToCaret()
		)

-- //////////////////////////// Function text colorer
	fn text_colorer start_point end_point colorcode = (
		output_window.outputtext.SelectionStart = start_point
		output_window.outputtext.SelectionLength = end_point
		
		if colorcode == "green" then (
		output_window.outputtext.selectionBackColor = output_window.outputtext.selectionBackColor.PaleGreen
		output_window.outputtext.DeselectAll 
			goto_last_line()
			 )
		else if colorcode == "red" then (
		output_window.outputtext.selectionBackColor = output_window.outputtext.selectionBackColor.Tomato
		output_window.outputtext.DeselectAll 
			goto_last_line()
			)
		else if colorcode == "yellow" then (
		output_window.outputtext.selectionBackColor = output_window.outputtext.selectionBackColor.Wheat
		output_window.outputtext.DeselectAll 
			goto_last_line()
			)
		else if colorcode == "blue" then (
		output_window.outputtext.selectionBackColor = output_window.outputtext.selectionBackColor.PowderBlue
		output_window.outputtext.DeselectAll 
			goto_last_line()
			)
		else if colorcode == "pink" then (
		output_window.outputtext.selectionBackColor = output_window.outputtext.selectionBackColor.Thistle
		output_window.outputtext.DeselectAll 
			goto_last_line()
			)
		)

-- //////////////////////////// Function to text adder		
	fn text_adder	text_to_write	text_color = (
		
		--gets the current character count in richtextbox
		before_character_count = output_window.outputtext.text.count
		--appends the massage in to the richtextbox
		output_window.outputtext.AppendText (text_to_write)
		--gets the character count after the massege is appended
		after_character_count = output_window.outputtext.text.count
		--get the number of characters in the last massege
		num_of_characters_to_select = after_character_count - before_character_count
		
		--send the collected data to text colorer
		text_colorer	 before_character_count	 num_of_characters_to_select 	text_color
		
		)	


--//

function output_generator object_name event_type =(
	if event_type== "in_sucess_icons" then (		
	status_msg =  ("\r\n" + object_name + "... file copied successfully")
	text_adder 		status_msg		"green"
	free status_msg
	)
	else if event_type== "in_sucess_script" then (		
	status_msg =  ("\r\n" + object_name + "... file copied successfully")
	text_adder 		status_msg		"blue"
	free status_msg
	)
	else if event_type== "in_sucess_folder" then (		
	status_msg =  ("\r\n" + object_name + "... folder created successfully")
	text_adder 		status_msg		"green"
	free status_msg
	)
	else if event_type=="in_error" then (
	status_msg =  ("\r\n" + object_name + "... FAILED TO INSTALL!")
	text_adder 		status_msg		"red"
	free status_msg	
		)
	else if event_type=="in_error_folder" then (
	status_msg =  ("\r\n" + object_name + "... FAILED TO CREATE THE FOLDER!")
	text_adder 		status_msg		"red"
	free status_msg	
		)	
		
		
	else if event_type=="un_sucess_icons" then (
	status_msg =  ("\r\n" + object_name +  "... uninstalled successfully")
	text_adder 		status_msg		"pink"
	free status_msg
		)
	else if event_type=="un_sucess_script" then (
	status_msg =  ("\r\n" + object_name +  "... uninstalled successfully")
	text_adder 		status_msg		"yellow"
	free status_msg
		)
		
	else if event_type=="un_error" then (
	status_msg =  ("\r\n" + object_name +  "... FAILED TO UNINSTALL!")
	text_adder 		status_msg		"red"
	free status_msg
		)
	
	)
	

fn get_all_files =(
	usericons = getINISetting setup_INI	"setup_info"	"usericons"
	userscripts = getINIsetting setup_INI	"setup_info"	"userscripts"
	usermacros = getINISetting setup_INI "setup_info"	"usermacros"	
	
	usericons_array= execute usericons
	userscripts_array= execute userscripts
	usermacros_array= execute usermacros
	
	)	
		
-- ////////////////////////////  Function to see if script is installed
	fn see_if_already_installed = (
		already_installed=0
		-- see if script is installed
		for i=1 to usericons_array.count do (
			see_if_icon_exists = doesFileExist (user_icons_path + usericons_array[i])
			if see_if_icon_exists == false then
				(
					already_installed=already_installed+1
					
					)
			)
		
		if already_installed == 0 then (
			uninstall_button .enabled=true
			install_button .enabled= false
			)
			else (
			uninstall_button .enabled=false
			install_button .enabled= true
				)
		)


		
-- //////////////////////////// Function to install everything.	
	function installer = (
		--Get all the files form the INI
		get_all_files()
		
		--Loop to run times equal to file count to copy
		for i=1 to usericons_array.count do (
			icon_to_copy = source_icon_path + usericons_array[i]
			icon_destination = user_icons_path + usericons_array[i]
			icon_copy_sucess = copyfile icon_to_copy icon_destination
			
				if icon_copy_sucess == true then (
					output_generator usericons_array[i] "in_sucess_icons"
					)
					else (
					output_generator usericons_array[i] "in_error"
						)
			)

		--Creates Script directory	
		create_script_dir=makeDir 	(user_scripts_path+script_folder_name)
			--Continues if Script directory is created sucessfully
			if create_script_dir==true then (
				output_generator script_folder_name "in_sucess_folder"
		
		--Loop to run times equal to file count to copy		
		for i=1 to userscripts_array.count do (
			script_to_copy = source_scripts_path + userscripts_array[i]
			script_destination = (user_scripts_path +script_folder_name) + userscripts_array[i]
			script_copy_sucess = copyfile script_to_copy script_destination
			
				if script_copy_sucess == true then (
					output_generator userscripts_array[i] "in_sucess_script"
					)
					else (
					output_generator userscripts_array[i] "in_error"
						)
			)
		)
		else (
			output_generator script_folder_name "in_error_folder"
			)
		
		--Loop to run times equal to file count to copy	
		for i=1 to usermacros_array.count do (
			macro_to_copy = source_macros_path + usermacros_array[i]
			macro_destination = user_macros_path + usermacros_array[i]
			macro_copy_sucess = copyfile macro_to_copy macro_destination
				
			if macro_copy_sucess == true then (
				output_generator usermacros_array[i] "in_sucess_script"
					)
					else (
					output_generator usermacros_array[i]  "in_error"
						)
			)
		macros.load (user_macros_path)
		execute end_msg

)


--//////////////////////////// Fucntion to uninstall everything	
		fn uninstaller = (
		--Get all the files from the INI	
		get_all_files()
		
		--Loop to run times equal to file count to delete
		for i=1 to usericons_array.count do (
			icon_to_delete = user_icons_path + usericons_array[i]
			delete_icon_sucess = deleteFile icon_to_delete
			
				if delete_icon_sucess == true then (
					output_generator usericons_array[i]  "un_sucess_icons"
					)
					else (
					output_generator usericons_array[i]  "un_error"
						)
			)
		
		--Loop to run times equal to file count to copy			
		for i=1 to userscripts_array.count do (
			script_to_delete = user_scripts_path +script_folder_name+ userscripts_array[i]
			delete_script_sucess= deleteFile script_to_delete
			
				if delete_script_sucess == true then (
					output_generator userscripts_array[i]  "un_sucess_script"
					)
					else (
					output_generator userscripts_array[i]  "un_error"
						)
			)
		
		--Loop to run times equal to file count to copy			
		for i=1 to usermacros_array.count do (
			macro_to_delete = user_macros_path + usermacros_array[i]
			delete_macro_sucess = deleteFile macro_to_delete
			
				if delete_macro_sucess == true then (
				output_generator usermacros_array[i]  "un_sucess_script"
					)
					else (
					output_generator usermacros_array[i]  "un_error"
						)
			)

)


--/////////////////////////////////////////////////////////////////////////////END OF FUNCTIONS
--////////////////////////////////////////////////////////////////////////////STARTING EVENTS		
		
-- on windows displays
on syscale_installer open do (
	print "mcr installer v2.0 by Ravihara Weerathunge (http:\\ravihara.com)"
	get_all_files()
	see_if_already_installed ()
	createdialog output_window 248 140 style:#(#style_toolwindow)
	main_dp = getDialogPos syscale_installer
	new_dp= main_dp + [-260,-20]
	SetDialogPos output_window new_dp
	grp1.caption = group_name
	output_window.outputtext.text = "mcr installer v2.0\r\nwritten by ravihara weerathunge\r\n(http:\\www.ravihara.com)\r\n--------------------------------"
	--dotNet.addEventHandler output_window.outputtext "TextChanged" refresh_textbox
	--)
	)
	
	
on syscale_installer close do(
	DestroyDialog output_window
	--deleteFolder folderPath:"C:\\temp\\FumeSScale"
	)			

	
-- when install button is pressed		
on install_button pressed do (
	installer()
	see_if_already_installed()
	colorman.reInitIcons()
	)

-- when uninstall button is pressed	
on uninstall_button pressed do (
	uninstaller()
	see_if_already_installed()
	colorman.reInitIcons()
	)
)-- DIALOG 1 END


see_if_bmp_exists = doesFileExist logo_bitmap_file
if see_if_bmp_exists == true then (
	createdialog syscale_installer 208 104
	)
	
else (
	messagebox "Archive is Damaged or Incomplete! Please download again." title: "Archive Error"
	)
	
)