macroScript ABcontrol category:"Max Override" tooltip:"Enable/Disable autobackup"  buttontext:"QAutoback"  Icon:#("MaxOverride",5)
(
	--unregister allthe callbacks
	try(unregisterRedrawViewsCallback ab_reminder) catch (print "No Callbacks to Unregister!")
	callbacks.removeScripts #viewportChange id:#ViewSwtcd

--//////////////////DICLARATION OF VARIABLES
global	write_on_vp
global 	viewport_switch_trigger
global 	before_av= viewport.activeViewport	

--/////////////////DICLARATION OF FUNCTIONS
--FUNCTION : Viewport refresher
fn viewport_switch_trigger= (
--get the current active viewport id
curent_av=viewport.activeViewport
	--see if the viewport has changed, using comparision between before viewport id and now veiwport id
	if before_av != curent_av then (
		--if viewports have changed, refresh the view, by unregistering and re-registering the redraw views callback
		unregisterRedrawViewsCallback ab_reminder
		registerRedrawViewsCallback  ab_reminder
		--sets the current viewport id as the before viewport id
		before_av=viewport.activeViewport
	)	
)

--FUNCTION: Write on Viewport
function	write_on_vp	stuff_to_write		textcolor	h_pos	v_pos =	(
	gw.htext [v_pos,h_pos,0] stuff_to_write color:textcolor
	gw.updateScreen() 
	)

--AUTOBACKUP REMINDER FUNCTION
function ab_reminder =	(
write_on_vp "ab:off" [255,000,00]	5 10
)
	

if autosave.Enable == false then 
	(
	autosave.Enable=true
	unregisterRedrawViewsCallback ab_reminder
	callbacks.removeScripts #viewportChange id:#ViewSwtcd
	print "AutoBackup Enabled"
	)
	else 
	(
		autosave.Enable=false
		registerRedrawViewsCallback  ab_reminder
		print "AutoBackup Disabled!"
		callbacks.addScript #viewportChange "viewport_switch_trigger()" id:#ViewSwtcd
		
		)
)
