macroScript hairdisplay category:"Max Override" tooltip:"Enable/Disable viewport hair display"  buttontext:"HairDis"  Icon:#("MaxOverride",6)
(
	--////////if no object is selected, script hides/ shows hair on all the hair geometry on the scene.
	if $==undefined then (
	try (
		for obj in objects do (
			try (
			current_state= obj.Hair_and_Fur.displayShowHairs
			if 	current_state == true then (hairs_visible="true") else (hairs_visible="false")
			if hairs_visible=="false" then (obj.Hair_and_Fur.displayShowHairs = on) else  (obj.Hair_and_Fur.displayShowHairs = off)
			)catch ()
		)
	)catch ()
)

--///////if user have a selection, while running the script, 
else

(
--defining the values.
	error_state="no"
	visibles=0
	hiddens=0
	
	try(
		for obj in selection do (
--try to determine if there is a valid object selection.
			try(current_state_of_selected = obj.Hair_and_Fur.displayShowHairs) catch()
			if (current_state_of_selected !=true) and (current_state_of_selected !=false) then (error_state="yes")
			else if (current_state_of_selected ==true) then visibles+=1 else if (current_state_of_selected ==false) then hiddens+=1
			)
-- if there are no errors, and there are objects with hair visible, than hair visibility set to off, turns of hair visiblity of all of them.
		if error_state=="no" and visibles>hiddens or visibles==hiddens then (
			for obj in selection do (
			try(obj.Hair_and_Fur.displayShowHairs=off) catch()
				)
			)
--if there are no errors on the selection, and objects with hair hidden are more than objects with hair visible, turn on the hair visibility of all of them.
		else if error_state=="no" and visibles<hiddens then (
			for obj in selection do (
			try(obj.Hair_and_Fur.displayShowHairs=on) catch()
				)
			)
--if there is an error in the selection (invalid object; an object without hair and fur modifier applied to it)
		else if error_state=="yes" then (messagebox "You have an invalid object in your selection. Please make sure, only to select objects that have hair and fur modifier applied.")
--free the values
				free error_state
				free visibles
				free hiddens				
	)catch()
)

)
